// YYMMDD.cpp for Calendar 981114
// Last Update 981121

#include "YYMMDD.h"
#include <time.h>

int32	year;
int32	month;
int32	week;
int32	day;
int32	dayOfWeek;	
int32	thisYear;								//981121
int32	thisMonth;								//981121
//char	fileNames[7][10];
char	fileYear[7][6];
char	fileMonth[7][4];
char	fileDay[7][4];
char	*dowList[7] = {
	"Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
};

char	timebuf[30];
time_t	ltime;
char	monthName[4];
char	dowName[4];
char	*monthList[12] = {
	"Jan", "Feb", "Mar", "Apr", "May", "Jun",
	"Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
};


void
getToday()
{
	// get current time
	time( &ltime );
	strcpy( timebuf, ctime( &ltime ) );
	// get year
	year = thisYear = atoi( timebuf+19 );			//981121
	// get month
	
	strncpy( monthName, timebuf+4, 3 );
	for (month=1; month < 13; month++)
		if ( !strcmp( monthName, monthList[month-1] ) )
			break;
	thisMonth = month;								//981121
	// get day
	day = atoi( timebuf+8 );
	//get day of the week
	strncpy( dowName, timebuf, 3 );
	for (dayOfWeek= 0; dayOfWeek < 7; dayOfWeek++ )
		if ( !strcmp( dowName, dowList[dayOfWeek] ) )
			break;
	// get fileNames for this week
	//getFileNames( year, month, day );	
	
}

static int32 monthLengths[] = {31,28,31,30,31,30,31,31,30,31,30,31};

long 
daysInMonth(int32 y, int32 m)
{
    if ((m==2)&& isLeap(y))
        return 29;
    else
        return monthLengths[m-1];
}

int32 
getDayOfWeek( int32 y, int32 m, int32 d )
{
	int32 days[]= {0,31,59,90,120,151,181,212,243,273,304,334};
	int32 k=y-1;
	
	d += 365*k+(k/4)-(k/100)+(k/400)+days[m-1];
	if (isLeap(y) && m>2) d++;
	return (int32)d%7;
}

//void
//normalizeYMD()
//{
//	while ( month > 12 ) {
//		month -= 12;
//		year++;
//	}
//	while ( month <= 0 ) {
//		month += 12;
//		year--;
//	}
//	while (day > daysInMonth( year, month )) {
//		day -= daysInMonth( year, month );
//		if ( ++month > 12 ) {
//			month = 1;
//			year++;
//		}
//	}
//	while ( day <= 0 ) {
//		if ( --month == 0 ) {
//			year--;
//			month = 12;
//		}
//		day += daysInMonth( year, month );
//	}
//}


	

	
		
	
